"use strict";

{
  const C3 = self.C3;
  C3.Plugins.skymen_skinsCore.Acts = {
    AddSkin(obj, skin, mode, anim, subskin) {
      if (this.skins[skin] == undefined) {
        this.skins[skin] = {};
      }
      this.lastSkin = skin;
      this.trigger();
      if (mode == 0) {
        for (var i = 0; i < obj._animations.length; i++) {
          var anim = obj._animations[i].GetName();

          this.skins[skin][anim] = {
            type: obj,
            anim: anim,
          };
          this.lastSubSkin = anim;
          this.trigger(true);
        }
      } else {
        this.skins[skin][subskin] = {
          type: obj,
          anim: anim,
        };
        this.lastSubSkin = anim;
        this.trigger(true);
      }
    },
    AddSubSkin(obj, skin, subskin, anim) {
      if (this.skins[skin] == undefined) {
        this.skins[skin] = {};
      }

      this.skins[skin][subskin] = {
        type: obj,
        anim: anim,
      };
      this.lastSubSkin = anim;
      this.trigger(true);
    },
    RemoveSkin(skin) {
      if (this.skins[skin] != undefined) {
        delete this.skins[skin];
      }
    },
    RemoveSubSkin(skin, subskin) {
      if (
        this.skins[skin] != undefined &&
        this.skins[skin][subskin] != undefined
      ) {
        delete this.skins[skin][subskin];
      }
    },
    Init() {
      if (this.init) return;

      for (var i = 0; i < this.instances.length; i++) {
        this.instances[i].updateSkin();
      }
      this.init = true;
    },
  };
}
